

program Sparse_decon_mixed_linear
  use sep
  use util_axisIO

  !use solver_reg_nrm_bd_mod
  use solver_smp_nrm_mod
  use solver_smp_nrm_timevariant_mod
  use plane_search_mod
  use plane_search_vt_mod
  use mask1

  use t_conv_filter_combine  
  use t_conv_filter
  use t_conv_data   
  use misc

  implicit none

  integer :: n1,n2
  type(myaxis)  axis1, axis2, axis_iter,axis_wavelet,axis_res

  ! <in.H Sparse_decon filt=filter.H > out.H



  integer ::filter_len

  integer                          :: niter_nl,niter_lin, iter_nl

  real                             :: qnt_d,qnt_m
  real                             :: r_th_d, r_th_m, r_th_m_origi
  logical                          :: l_use_rthd, l_use_rthm


  integer :: zero_lag
  integer :: max_overshot_cnt

  real, dimension(:),allocatable :: tmp_ar
  integer :: psiter      !maximum iterations allowed in plan search
  integer :: qt_period   !Allow quantile change after certain iterations

  character(12)  ::str_norm_mod, str_norm_dat
  integer        ::stat

  real, dimension(:), allocatable :: error
  integer :: niter0

  logical bsave,T,F
  integer i,j,k, nframe,n12

  logical :: bUseMask
  type(myaxis) :: axisT,axisTb,axis_dummy

  integer:: iRecord, iFilterLen,maxConvLength,iShift,iFilterbLen;
  
  !real, allocatable, dimension(:) :: filter_specreg
  real, dimension(:),allocatable:: d,b_r_d_conv,d_a_conv_r,d_conv_a,dd,model_a,model_b,a_r_b_d_conv,d_a_conv
  real, dimension(:),allocatable::d_conv_delta_a,d_delta_a_delta_rb
  real, dimension(:), allocatable :: a,b,ra,rb,wavelet,convRes
  real, dimension(:),allocatable:: delta_a, delta_b,delta_rb
  real, dimension(:),allocatable:: delta_rb_a,init_filter_A,init_filter_B
  logical, pointer, dimension(:) :: maska, maskb
  integer gap
  real :: maxV

real, dimension(:),allocatable::test,result_test
  
  !All the tags in params
  character(len=256) :: csz_filterA,csz_filterB,csz_qntd,csz_qntm,csz_niter_nl, &
  & csz_niter_lin,csz_psiter,csz_qt_period,csz_filt_len,csz_filtb_len,&
  & csz_model_b,csz_wavelet, csz_convRes, csz_gap, &
  & csz_init_filterA, csz_init_filterB,csz_init_filter_a_filename,csz_init_filter_b_filename, &
  & csz_res_filename, &
  & csz_rt_array_filename, csz_rt_array

  integer iInitFilterALength,iInitFilterBLength,iia,iib
  real res_scale

  logical :: is_vt
  real, dimension(:),allocatable::rt_array
  integer, dimension(:),allocatable::vt_idx
  integer:: idx

  double precision :: debug_arg1 ,debug_arg2
  integer csz_rt_array_length,csz_rt_array_n1,csz_rt_array_n2
  real :: temp_min_abs

  is_vt=.false.

  csz_filterA = "filter_a"
  csz_filterB = "filter_b"
  csz_init_filterA = "init_filter_a"
  csz_init_filterB = "init_filter_b"
  csz_qntd = "qnt_d"
  csz_qntm = "qnt_m"
  csz_niter_nl = "niter_nl"
  csz_niter_lin = "niter_lin"
  csz_psiter = "psiter"
  csz_qt_period = "qt_period"
  csz_filt_len = "filt_length"
  csz_filtb_len= "filtb_length"
  csz_model_b = "model_b"
  csz_wavelet = "wavelet"
  csz_convRes = "conv_res"
  csz_gap = "gap"
  csz_rt_array="rt_array"
!   csz_res_filename="res_filename"
  T = .true. ; F = .false.
  !Params
  call sep_init()

  call from_param("UseMask",bUseMask,.false.)

  call hinaxis(axis1,1)
  call hinaxis(axis2,2)
  n1 = axis1%n; n2 = axis2%n
  n12 = n1*n2

  call from_param (csz_niter_nl, niter_nl, 1)
  call from_param (csz_niter_lin, niter_lin, 1)   !should be a small number
  write(0,*) "niter_nl/lin=",niter_nl, niter_lin

  call from_param (csz_psiter,psiter,2); write(0,*) "psiter=",psiter

  call from_param (csz_qt_period,qt_period,1000); 
  write(0,*) csz_qt_period,"=",qt_period
  
  call from_param ("max_overshot_shrink_cnt", max_overshot_cnt, 0)
  write(0,*) "max_overshot_cnt=", max_overshot_cnt

  call from_param   (csz_qntd, qnt_d, .9) 
  call from_param   (csz_qntm, qnt_m, .9) 
  write(0,*) "quantile d/m = ", qnt_d,qnt_m

  call from_param ("r_th_d", r_th_d, -1.0)
  write(0,*) "r_th_d = ", r_th_d

  call from_param   ("norm_dat", str_norm_dat, 'l2')
  write(0,*) "norm dat residue=", str_norm_dat

  call from_param (csz_filt_len, iFilterLen)
  call from_param (csz_filtb_len, iFilterbLen, iFilterLen) !Default filter a,b equal length
  write(0,*) 'filter length=', iFilterLen, ' / ', iFilterbLen 
  call from_param (csz_gap, gap,0)
  write(0,*) 'gap =', gap
  call from_param  ('zero_lag', zero_lag, 0)  !Default 0, means causal filter

  call from_param ('res_filename',csz_res_filename,'NULL')
!   write(0,*) 'aaaaa',csz_res_filename

  !for initial guess
  call from_param (csz_init_filterA,csz_init_filter_a_filename,'NULL')
  if (csz_init_filter_a_filename.ne.'NULL') then
    call from_aux(csz_init_filter_a_filename,'n1',iInitFilterALength)
    allocate(init_filter_A(iInitFilterALength))
    call sep_read(init_filter_A,csz_init_filter_a_filename)
    write(0,*) 'init_filter_A',init_filter_A
!     write(0,*) 'init a',iInitFilterALength,csz_init_filterA, csz_init_filter_a_filename

  endif 

  call from_param (csz_init_filterB,csz_init_filter_b_filename,'NULL')
  if (csz_init_filter_b_filename.ne.'NULL') then
    call from_aux(csz_init_filter_b_filename,'n1',iInitFilterBLength)
    allocate(init_filter_B(iInitFilterBLength))
    call sep_read(init_filter_B,csz_init_filter_b_filename)
!     write(0,*) init_filter_B
!     write(0,*) 'init b',iInitFilterBLength,csz_init_filterB, csz_init_filter_b_filename
  endif



  call from_param (csz_rt_array,csz_rt_array_filename,'NULL')
  if (csz_rt_array_filename.ne.'NULL') then
    call from_aux(csz_rt_array_filename,'n1',csz_rt_array_n1)
    call from_aux(csz_rt_array_filename,'n2',csz_rt_array_n2)
    csz_rt_array_length=csz_rt_array_n1*csz_rt_array_n2
    if (csz_rt_array_length.ne.n12) call erexit('csz_rt_array_length.ne.n12')
    allocate(rt_array(n12),vt_idx(n12))

    do idx=1,n12
      vt_idx(idx)=idx
    end do

    call sep_read(rt_array,csz_rt_array_filename)

    rt_array = abs(rt_array)     ! Rt is positive
    
    temp_min_abs=10000000

    do idx=1,n12
      if (rt_array(idx)>0) then
        temp_min_abs=min(temp_min_abs,rt_array(idx))
      end if
    end do
!     temp_min_abs=minval(rt_array)

    if (temp_min_abs.eq.0 .or. temp_min_abs.eq.10000000) call erexit('minval(abs(rt_array))=0')

    do idx=1,n12
      if (rt_array(idx).eq.0) rt_array(idx)=temp_min_abs
    end do

    debug_arg1=sum(rt_array)/n12

    write(0,*) 'csz_rt_array_filename',csz_rt_array_filename

!     write(0,*) 'rt check',rt_array(600:610)

!     write(0,*) 'init a',iInitFilterALength,csz_init_filterA, csz_init_filter_a_filename
    is_vt=.true.
  endif 

  axis1.l = "time(sec)"
  axis2.l = "x(km)"
  !!Output model A
  call houtaxis(axis1,1)
  call houtaxis(axis2,2)
  !!output model B
  csz_model_b = "model_b"
  call houtaxis(axis1,1,csz_model_b)
  call houtaxis(axis2,2,csz_model_b)

  !SET THE DIMENSIONS of OUTPUT DUMP FILE
  iRecord = 1
  nframe = (niter_nl-1)/iRecord + 2
  write(0,*) "nframe=",nframe
 
  call set_axis(axisT,iFilterLen,axis1.d,0.0,axis1.l)
  call set_axis(axisTb,iFilterbLen,axis1.d,0.0,axis1.l)
  call set_axis(axis_iter,nframe,1.0,0.0,"iter No.")

  call houtaxis(axisT,1, csz_filterA)
  call houtaxis(axisTb,1, csz_filterB)
  call set_axis(axis_dummy,1,1.0,1.0,"")
  call houtaxis(axis_dummy,2,csz_filterA)
  call houtaxis(axis_dummy,2,csz_filterB)

!   axis_iter%o=0.
  call houtaxis(axis_iter,3,csz_filterA)
  call houtaxis(axis_iter,3,csz_filterB)


  call houtaxis(axis_iter,3,csz_model_b)
  call houtaxis(axis_iter,3)

  if (csz_res_filename.ne.'NULL') then
    axis_res%n=2
    axis_res%o=0
    axis_res%d=1
    axis_res.l = "scaled"
    call houtaxis(axis_res,1,csz_res_filename)
    axis_res%n=niter_nl*niter_lin
    axis_res%o=1
    axis_res%d=1
    axis_res.l = "iter"
    call houtaxis(axis_res,2,csz_res_filename)
  end if




  maxConvLength = 512 !have enough length
  
	allocate (d(n12),b_r_d_conv(n12),a_r_b_d_conv(n12),&
  				& dd(n12), model_a(n12),d_conv_a(n12),d_a_conv(n12))

  allocate (a(iFilterLen), b(iFilterbLen),ra(iFilterLen),rb(iFilterbLen))
  allocate (delta_a(iFilterLen), delta_b(iFilterbLen),delta_rb(iFilterbLen))
  allocate(d_conv_delta_a(n12),d_delta_a_delta_rb(n12))
  allocate (maska(iFilterLen+iFilterbLen))
  allocate (delta_rb_a(iFilterLen+iFilterbLen))
  allocate (wavelet(maxConvLength),convRes(maxConvLength))

  wavelet=0; convRes=0

  call sep_read(wavelet,csz_wavelet)
  !write(0,*) 'wavelet: ', wavelet

  d = 0; ra = 0; rb = 0
  b_r_d_conv = 0; d_a_conv_r = 0
  a_r_b_d_conv=0
  a = 0; b = 0
  model_a = 0; model_b = 0
  delta_rb_a=0
  delta_a=0; delta_b=0; delta_rb=0

  !deallocate !!!

!   ! Use initial wavelet
!   a(1+zero_lag) = 1.0
!   
!   b(1+zero_lag) = 1.0
!  ! rb(iFilterblen)=1.0

  if (csz_init_filter_a_filename.eq.'NULL') then
    a(1+zero_lag) = 1.0 !!!comment for init b filter
  else if  (iFilterLen.lt.iInitFilterALength) then
    do iia=1,iFilterLen
    a(iia)=init_filter_A(iia)
    end do
 else if (iFilterLen.ge.iInitFilterALength) then
   a(1:iInitFilterALength)=init_filter_A(:)
  endif

  if (csz_init_filter_b_filename.eq.'NULL') then
    b(1+zero_lag) = 1.0 !!!comment for init b filter
  else if (iFilterbLen.lt.iInitFilterBLength) then
    do iib=1,iFilterbLen
    b(iib)=init_filter_B(iInitFilterBLength-iFilterbLen+iib)
    end do
  else if (iFilterbLen.ge.iInitFilterBLength) then
   b(iFilterbLen-iInitFilterBLength+1:iFilterbLen)=init_filter_B(:)
  endif




  maska = .true.
  maska(1+zero_lag+iFilterblen) = .false.
  maska(1+zero_lag+iFilterblen-1) = .false.
  !Apply gap to the mask




  call sep_read(d)
!       write(0,*) 'data check',d(600:610)
  !write(0,*) "d= ",d
  if (csz_init_filter_b_filename.eq.'NULL') then
    call reverseArray(b,rb,iFilterbLen,1)
  else
    rb=b
  end if

  write (0,*) a
  write (0,*) b

!!!!!!!!!!!test
! allocate(test(iFilterlen+iFilterblen),result_test(n12))
! test=0;
! test(1)=1.0;test(iFilterblen)=1.0;
!   call t_conv_data_init(a,n1,n2)
!   stat = t_conv_data_lop(.false.,.false.,d,d_conv_a)
!   call t_conv_data_init(rb,n1,n2)
!   stat = t_conv_data_lop(.false.,.false.,d,b_r_d_conv)
!   call t_conv_filter_combine_init(d_conv_a,b_r_d_conv,n1,n2,iFilterbLen)
!   stat=t_conv_filter_combine_lop(.false.,.false., test,result_test)
!  write(0,*) 'd',d
!   write(0,*) 'd*a',d_conv_a
!   write(0,*) 'd*rb',b_r_d_conv
!   write(0,*) 'test',test
!   write(0,*) 'combine',result_test
! deallocate(test,result_test)




do iter_nl=1, niter_nl+1



  !Linearized inversion

  !d*a
  call t_conv_data_init(a,n1,n2)
  stat = t_conv_data_lop(.false.,.false.,d,d_conv_a)

  !d*rb  
  !call reverseArray(b,rb,iFilterbLen,1)
  !write(0,*) "rb=", rb
  call t_conv_data_init(rb,n1,n2)
  stat = t_conv_data_lop(.false.,.false.,d,b_r_d_conv)

  !d*a*rb
  call t_conv_filter_init(d_conv_a,n1,n2)
  stat = t_conv_filter_lop(.false.,.false.,rb,a_r_b_d_conv)

!   !d*delta_a*delta_rb
!    call t_conv_data_init(delta_a,n1,n2)
!    stat = t_conv_data_lop(.false.,.false.,d,d_conv_delta_a)
!    call t_conv_filter_init(d_conv_delta_a,n1,n2)
!    stat = t_conv_filter_lop(.false.,.false.,delta_rb,d_delta_a_delta_rb)
 


  delta_a=0; delta_b=0; delta_rb=0
  !call reverseArray(delta_b,delta_rb,iFilterbLen,1)
  delta_rb_a(1:iFilterbLen)=delta_rb(1:iFilterblen)
  delta_rb_a(iFilterbLen+1:)=delta_a(1:iFilterlen)
!!!################################################## Error Dump

     !dump filter a0 and model m0 to file
     bsave = (mod(iter_nl-2,iRecord) .eq. 0 .and. iter_nl.ge.1)
     if (bsave) then
        write(0,*) "bsave==true, at iter",iter_nl
        call sep_write(a,csz_filterA)
  call t_conv_data_init(a,n1,n2)
  stat = t_conv_data_lop(.false.,.false.,d,d_a_conv)
  call t_conv_filter_init(d_a_conv,n1,n2)
  stat = t_conv_filter_lop(.false.,.false.,rb,model_a)
  call shiftArray(model_a,n1,n2,iFilterblen-1)
        call sep_write(model_a)

     end if

!!!################################################## Error Dump
     if (bsave) then
        call sep_write(rb,csz_filterB)
     end if

  if (iter_nl .eq. niter_nl+1) exit

  !Init opertor
  !write(0,*) "b_r_d_conv",b_r_d_conv

  call t_conv_filter_combine_init(d_conv_a,b_r_d_conv,n1,n2,iFilterbLen)
  dd = 0

  call mask1_init(maska)


  if (.not.is_vt) then
    if (abs(r_th_d + 1.0)<1e-5) then !use quantile
	  call solver_smp_nrm(m=delta_rb_a, m0=delta_rb_a, d=dd-a_r_b_d_conv, Fop=t_conv_filter_combine_lop, Jop=mask1_lop, &
          & stepper=cgstep_ps,niter=niter_lin,&
          & norm_in=str_norm_dat,&
          & qnt=qnt_d, &
          & psiter=psiter, overshot_shrink_max_cnt_in=max_overshot_cnt, qt_period_in=qt_period,&
          & resd=model_a,&
          & res_filename=csz_res_filename,res_scale=res_scale)
    else
	  call solver_smp_nrm(m=delta_rb_a, m0=delta_rb_a, d=dd-a_r_b_d_conv, Fop=t_conv_filter_combine_lop, Jop=mask1_lop, &
          & stepper=cgstep_ps,niter=niter_lin,&
          & norm_in=str_norm_dat,&
          & R_th_in=r_th_d, &
          & psiter=psiter, overshot_shrink_max_cnt_in=max_overshot_cnt, qt_period_in=qt_period,&
          & resd=model_a,&
          & res_filename=csz_res_filename,res_scale=res_scale)
    endif
  else
	  call solver_smp_nrm_vt(m=delta_rb_a, m0=delta_rb_a, d=dd-a_r_b_d_conv, Fop=t_conv_filter_combine_lop, Jop=mask1_lop, &
          & stepper=cgstep_ps_vt,niter=niter_lin,&
          & norm_in=str_norm_dat,&
          & R_th_in=r_th_d, &
          & psiter=psiter, overshot_shrink_max_cnt_in=max_overshot_cnt, qt_period_in=qt_period,&
          & resd=model_a,&
          & res_filename=csz_res_filename,res_scale=res_scale,&
          & rt_array=rt_array,vt_idx=vt_idx)
  endif
  
  delta_rb(1:iFilterblen)=delta_rb_a(1:iFilterbLen)
  delta_a(1:iFilterlen)=delta_rb_a(iFilterbLen+1:)
  write(0,*) "max delta_rb_a ",  maxval(abs(delta_rb_a))
  a=a+delta_a
  write(0,*) "max delta_a ",  maxval(abs(delta_a))
  !call reverseArray(delta_rb,delta_b,iFilterbLen,1)
  rb=rb+delta_rb
  write(0,*) "max delta_b ",  maxval(abs(delta_rb))
  !write(0,*) "Finish the call of solver_smp_nrm, step1"
  write(0,*) "max model_a", maxval(abs(model_a))
  

  if (.not.is_vt) then
    call solver_smp_nrm_close()
  else
    call solver_smp_nrm_vt_close()
  end if






end do ! linear iter loop

!   !convolve wavelet*a*rev(b)
!   call t_conv_filter_init(wavelet,maxConvLength,1)
!   stat = t_conv_filter_lop(F,F,a,convRes);
!   call t_conv_filter_init(convRes,maxConvLength,1)
!   stat = t_conv_filter_lop(F,F,rb,wavelet);
! 
!   call hinaxis(axis_wavelet,1,csz_wavelet);
!   axis_wavelet.n = size(wavelet)
!   call houtaxis(axis_wavelet,1,csz_convRes)
!   call sep_write(wavelet,csz_convRes)

  deallocate(maska,a,b,ra,rb)
  deallocate(d,dd,model_a,d_conv_a,b_r_d_conv,d_conv_delta_a,d_delta_a_delta_rb,d_a_conv)
  deallocate(a_r_b_d_conv,delta_a,delta_b,delta_rb,delta_rb_a)
  if (csz_init_filter_a_filename.ne.'NULL') then
  deallocate(init_filter_A)
  end if
  if (csz_init_filter_b_filename.ne.'NULL') then
    deallocate(init_filter_B)
  end if

  if (is_vt) then
    debug_arg2=sum(rt_array)/n12
    write(0,*) 'debug_arg1=',debug_arg1,'debug_arg2=',debug_arg2
    deallocate(rt_array,vt_idx)
  end if

  call sep_close()
end program
