program bidecon_log
  use sep
  use util_axisIO

  use my_FT
  use norm_mod1


  implicit none
  character(len=256)               :: csz_threshold,csz_flt_len_a,csz_flt_len_b,csz_niter,csz_niter_lin,csz_Cr,csz_FU,csz_u,csz_filter,csz_weight_opt,csz_du,csz_nup,csz_nun,csz_r
  integer                          :: n1,n2,i1,i2,i,niter,nw,iw,niter_lin,ni
  integer                          :: fil_len_a,fil_len_b,fil_len
  integer                          :: stat,stat2
  real                             :: threshold
  double complex                   :: c1dr,c2drr,alfa,alfa_temp
  real,allocatable                 :: data(:,:),model(:,:),output_u(:),output_FU(:),output_filter(:)
  real,allocatable                 :: clipr(:),gradient(:),clipr_temp(:,:),gradient_temp(:)
  double complex,allocatable       :: c0(:,:),c1(:,:),c2(:,:)
  double complex,allocatable       :: dat(:,:),FD(:,:)
  double complex,allocatable       :: u(:),FU(:),du(:),dFU(:)
  double complex,allocatable       :: r(:,:),FR(:,:),FC1(:,:)
  double complex,allocatable       :: ExpU(:),DEU(:,:)
  double complex,allocatable       :: dr(:,:),dFR(:,:)
  double complex,allocatable       :: ExpdU(:),dfilter(:),filter(:)
  double complex,allocatable       :: weight(:)
  type(myaxis)                     :: axis_iter,axis_dummy,axis1,axis2,axis_FU
  type(myaxis)                     :: axis_u
  integer                          :: nframe
  integer                          :: weight_opt,index1,index2,index3
  integer                          :: nup,nun
  real,allocatable                 :: avgr(:),avgr_temp(:,:)
  !!=============Input===========================
  call sep_init()
  csz_threshold = "threshold"
  csz_flt_len_a="fit_len_a"
  csz_flt_len_b="fit_len_b"
  csz_niter="niter"
  csz_niter_lin="niter_lin"
  csz_Cr="Cr"
  csz_FU="FU"
  csz_u="u"
  csz_filter="filter"
  csz_weight_opt="weight_opt"
  csz_du="du"
  csz_nup="weight_np"
  csz_nun="weight_nn"
  csz_r="avg_r"

  call from_param (csz_threshold, threshold, 0.1)
  call from_param (csz_flt_len_a, fil_len_a, 32)
  call from_param (csz_flt_len_b, fil_len_b, 32)
  call from_param (csz_niter, niter, 5)
  call from_param (csz_niter_lin, niter_lin, 5)
  call from_param (csz_weight_opt,weight_opt,0)
  call from_param (csz_nup,nup,30)
  call from_param (csz_nun,nun,5 )
  nframe=niter

  call hinaxis(axis1,1)!y
  call hinaxis(axis2,2)!x
  n1 = axis1%n; n2 = axis2%n
  nw=n1

  fil_len=n1 !fil_len_a+fil_len_b-1

  call set_axis(axis_dummy,1,1.0,1.0,"")
  call set_axis(axis_iter,nframe,1.0,1.0,"iter No.")

  !! ====model====
  call houtaxis(axis_iter,3)
  
  !!======H(r)=====
  call houtaxis(axis_dummy,2,csz_Cr)
  call houtaxis(axis_iter,1,csz_Cr)
  !!======Gradient(du)===
  call houtaxis(axis_dummy,2,csz_du)
  call houtaxis(axis_iter,1,csz_du)

  !!=====U(w)======
  call set_axis(axis_FU,nw,1.,0.0," ")
  call houtaxis(axis_FU,1,csz_FU)
  call houtaxis(axis_dummy,2,csz_FU)
  call houtaxis(axis_iter,3,csz_FU) 
  !!====u(t)=======

   call set_axis(axis_u,n1,axis1%d,0.0,"time(sec)")
  call houtaxis(axis_u,1,csz_u)
  call houtaxis(axis_dummy,2,csz_u)
  call houtaxis(axis_iter,3,csz_u) 
  !!====filter======
  call houtaxis(axis_u,1,csz_filter)
  call houtaxis(axis_dummy,2,csz_filter)
  call houtaxis(axis_iter,3,csz_filter) 
  !!===avg(r)/R======
  call houtaxis(axis_dummy,2,csz_r)
  call houtaxis(axis_iter,1,csz_r)
  !!===========begin===============================

  write(0,*) "nw=",nw,"fil_len=",fil_len
  allocate(u(fil_len),FU(nw),du(fil_len),dFU(nw))
  allocate(dat(n1,n2))
  allocate(data(n1,n2),FD(nw,n2),r(n1,n2),FR(nw,n2),dr(n1,n2),dFR(nw,n2),FC1(nw,n2),ExpU(nw),DEU(nw,n2),c0(n1,n2),c1(n1,n2))
  allocate(c2(n1,n2),model(n1,n2),output_u(fil_len),output_FU(nw),output_filter(fil_len),filter(fil_len))
  allocate(ExpdU(nw),dfilter(n1))
  allocate(weight(fil_len))
  allocate(clipr(niter),gradient(niter),clipr_temp(n1,n2),gradient_temp(fil_len))
  allocate(avgr(niter),avgr_temp(n1,n2))
  call sep_read(data)
  dat(:,:)=data(:,:)/maxval(data)*3
  
  write(0,*)"Code is updated a"

  do i2=1,n2
    call D_FT1D(dat(:,i2),FD(:,i2),n1,nw,.false.)  !FT
  end do
  write(0,*)'FD(complex)',sum(FD)


  u=0;


  !!!==========begin iteration===================
  do i=1,niter

    !=====output      
    model=real((r))
    write(0,*) 'model',sum(model)/n1/n2
    call sep_write(model)

    output_u=real((u))
    call sep_write(output_u,csz_u)
    output_FU=real((FU))
    call sep_write(output_FU,csz_FU)
    call D_FT1D(u,FU,fil_len,nw,.False.)
    do iw=1,nw
      ExpU(iw)=exp(FU(iw))
    end do
    call D_FT1D(filter,ExpU,fil_len,nw,.true.)
    output_filter=real(filter)

    call sep_write(output_filter,csz_filter)


    write(0,*) '================iteration===============',i
    call D_FT1D(u,FU,fil_len,nw,.False.)
    write(0,*)"u,FU before noter_linear",sum(u)/fil_len,sum(FU)/nw
    du=0
    dFU=0   !???????????
  
    !=======r==========
    do iw=1,nw
      ExpU(iw)=exp(FU(iw))
    end do
    write(0,*)"exp(U) before noter_linear",sum(ExpU)/nw
    do i2=1,n2
      do iw=1,nw
        DEU(iw,i2)=FD(iw,i2)*ExpU(iw)
      end do

      call D_FT1D(r(:,i2),DEU(:,i2),n1,nw,.True.)                               !r
   !   write(0,*)"r before niter_linear",sum(r)/n1/n2
      !=========du========================
      stat = hybrid_cmplx(threshold,r(:,i2), c0(:,i2), c1(:,i2), c2(:,i2))     !c1
      call D_FT1D(r(:,i2),FR(:,i2),n1,nw,.False.)                          !R
      call D_FT1D(c1(:,i2),FC1(:,i2),n1,nw,.False.)                        !C1
      do iw=1,nw
        dFU(iw)=dFU(iw)+CONJG(FR(iw,i2))*FC1(iw,i2)                    !dU
      end do
      !du
    end do   

     dFU=dFU-sum(dFU)/nw
     call D_FT1D(du,dFU,fil_len,nw,.true.)
     if (weight_opt==1) then
        weight=0.
      
        weight(1:nup)=(1.,0.)
!!!!!!!!!!!!
        weight(2:4)=(0.1,0.)
        weight(5)=(0.3,0.)
        weight(6)=(0.7,0.)
!!!!!!!!!!!!
        !weight(2)=(0.1,0.1)
        !weight(3)=(0.3,0.3)
        !weight(4)=(0.7,0.7)
        weight(nup+1)=(0.9,0.)
        weight(nup+2)=(0.6,0.)
        weight(nup+3)=(0.3,0.)

        index1=n1-nun
        weight(index1:n1)=(1.,0.)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        index2=n1-1
        index3=n1-2
        weight(index3:index2)=(0.1,0.)
        weight(n1-3)=(0.5,0.)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        !index2=n1
        !weight(index2)=(0.1,0.1)
        !weight(n1-1)=(0.5,0.5)
        weight(index1-1)=(0.9,0.)
        weight(index1-2)=(0.6,0.)
        weight(index1-3)=(0.3,0.)

    
        
      
        
     !    write(0,*)"weighting funtion is",weight
     !    write(0,*)"du before weighting",du
        do i1=1,n1
           du(i1)=du(i1)*weight(i1)
        end do
     !    write(0,*)"du after weighting",du 
        call D_FT1D(du,dFU,fil_len,nw,.False.)                                     !constain middle term to be 
     else
            dFU=dFU
            call D_FT1D(du,dFU,fil_len,nw,.False.) 
     end if
    !========dr===========================
    do i2=1,n2

      do iw=1,nw
        dFR(iw,i2)=FR(iw,i2)*dFU(iw)                                   !dR
      end do 
  !   write(0,*)"dFU,dFR",sum(dFU)/nw,sum(DFR)/nw/n1
      call D_FT1D(dr(:,i2),dFR(:,i2),n1,nw,.True.)                       !dr
    end do
    !!!updata alfa
  c1dr=0;c2drr=0;alfa=0
    do ni=1,niter_lin
      write(0,*) 'niter_lin',ni
      do i2=1,n2
        stat2 = hybrid_cmplx(threshold,r(:,i2), c0(:,i2), c1(:,i2), c2(:,i2)) 
        do i1=1,n1
          c1dr = -(c1(i1,i2)*dr(i1,i2))+c1dr                          ! c1dg = -C'*G
          c2drr=c2(i1,i2)*(dr(i1,i2)*dr(i1,i2))+c2drr
        end do
      end do                                                                
      alfa_temp=c1dr/c2drr
      if (weight_opt==1) then
         alfa_temp=alfa_temp*min(10,ni)/10
      else 
         alfa_temp=alfa_temp
      end if
      alfa=alfa+alfa_temp
      r=r+alfa_temp*dr
      !alfa=c1dr/c2drr+alfa              !alpha
      !r=r+c1dr/c2drr*dr
      write(0,*) "dr",sum(dr)/n1/n2
      write(0,*) "r,c1",sum(r)/n1/n2,sum(c1)/n1/n2
      write(0,*) "c1dr,c2drr",c1dr,c2drr
      write(0,*) "alfa",alfa
    end do

    u=u+alfa* du           
   write(0,*)"u",sum(u)/nw
   write(0,*)"du",sum(du)/nw
  !=========output
    clipr_temp=real((c0))
    clipr(i)=sum(clipr_temp)/n1/n2
    !clipr(i)=clipr(i)/clipr(1)
    write(0,*)"H(r) ab",clipr(i)
    
    gradient_temp=real(du)
    gradient(i)=sum((du))/n1
    !gradient(i)=gradient(i)/gradient(1)
    write(0,*)"gradient ab",gradient(i)
     do  i2=1,n2
        do i1=1,n1
           avgr_temp(i1,i2)=model(i1,i2)*model(i1,i2)+threshold*threshold
           avgr_temp(i1,i2)=avgr_temp(i1,i2)**(0.5)
        end do 
     end do
     
     avgr(i)=(sum(avgr_temp)/n1/n2)**(2)-threshold*threshold
     avgr(i)=avgr(i)**(0.5)
     avgr(i)=avgr(i)/threshold
  end do

  !model=real((r))
  !write(0,*) 'model',sum(model)/n1/n2
  !!=====output
  !call sep_write(model)
  call sep_write(clipr,csz_Cr)
  call sep_write(avgr,csz_r)
  call sep_write(gradient,csz_du)

  call sep_close()

  deallocate(u)
  deallocate(FU)
  deallocate(du)
  deallocate(dFU)
  deallocate(data,dat,FD,r,FR,dr)
  deallocate(dFR,FC1,ExpU,DEU,c0, c1, c2,model,clipr,output_u,output_FU,output_filter)
  deallocate(ExpdU,dfilter,filter)
  deallocate(weight)
  deallocate(gradient,clipr_temp,gradient_temp)
  deallocate(avgr,avgr_temp)
end program
