module my_FT
  implicit none


contains


subroutine D_FT1D(c,FC,nt,nw,adj)
!    double complex,intent(inout)::FC(nw),c(nw)
    double complex ::FC(nw),c(nw)
    double PRECISION, allocatable ::w(:)
    integer,intent(in) ::nt,nw
    integer::iw,it
    logical,intent(in)::adj
    real::fscale,bscale
    double PRECISION ::ow,dw,pi,ot,dt,t

    



    allocate(w(nw))

    w=0.

    pi = 2.*ACOS(0.0)
    dw = 2.*pi/(nw)
    ow = 0.
    ot=0.
    dt=2*pi/dw/nt!dt=1/df/nt
!     fscale=1./sqrt(1.*nt)
    fscale=1.
    bscale=1./nt


    if (adj) then
        c=(0.,0.)
    else
        FC=(0.,0.)
    end if


     do it=1,nt
         t=ot+dt*(it-1)
         do iw=1,nw
            w(iw) = ow  + (iw - 1) * dw
            if(adj) then!inverse FT
                c(it)=c(it)+FC(iw)*exp(cmplx(0,-w(iw)*t))*bscale
            else  !FT
                 FC(iw)=FC(iw)+c(it)*exp(cmplx(0,w(iw)*t))*fscale
            end if
         end do
     end do





    deallocate(w)
end subroutine

end module my_FT
